package com.jisco.dynamicweight.dynamicbasereciever.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicbasebatchdbconfig.model.DynamicBaseBatchdbConfig;
import com.jisco.dynamicweight.dynamicbasereciever.model.DynamicBaseReciever;
import com.jisco.dynamicweight.dynamicbasereciever.service.IDynamicBaseRecieverService;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.baseinfo.meterbasecalibrarelation.model.MeterBaseCalibraRelation;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * DynamicBaseReciever RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-12-31 02:55
 * 类描述
 * 修订历史：
 * 日期：2021-12-31
 * 作者：generator
 * 参考：
 * 描述：DynamicBaseReciever RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/dynamicbaserecievers")
public class DynamicBaseRecieverController extends BaseRESTfulController {

    @Autowired
    IDynamicBaseRecieverService dynamicBaseRecieverService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasereciever:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        PageList<DynamicBaseReciever> list = dynamicBaseRecieverService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasereciever:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        PageList<DynamicBaseReciever> list = dynamicBaseRecieverService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "创建", notes = "根据DynamicBaseReciever对象创建")
    @ApiImplicitParam(name = "dynamicBaseReciever", value = "详细实体dynamicBaseReciever", required = true, dataType = "DynamicBaseReciever")
    //@RequiresPermissions("dynamicbasereciever:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicBaseReciever model) {
        Assert.isTrue(StringUtils.isNotBlank(model.getReceiverName()), "请输入PIKA系统收货单位名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getReceiverCode()), "请输入PIKA系统收货单位编码！");
        Assert.isTrue(StringUtils.isNotBlank(model.getReceiverType()), "请输入PIKA系统收货点类型！");
        Assert.isTrue(StringUtils.isNotBlank(model.getDisSysName()), "请输入分料系统收货单位名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        model.setCreateManNo(UserUtil.getCurrentUserId());
        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicBaseReciever dynamicBaseReciever = dynamicBaseRecieverService.add(model);
        return success(dynamicBaseReciever);
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasereciever:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        DynamicBaseReciever dynamicBaseReciever = dynamicBaseRecieverService.getById(id);
        return success(dynamicBaseReciever);
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的dynamicBaseReciever信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "dynamicBaseReciever", value = "详细实体dynamicBaseReciever", required = true, dataType = "DynamicBaseReciever")
    })
    //@RequiresPermissions("dynamicbasereciever:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicBaseReciever model) {
        Assert.isTrue(StringUtils.isNotBlank(model.getReceiverName()), "请输入PIKA系统收货单位名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getReceiverCode()), "请输入PIKA系统收货单位编码！");
        Assert.isTrue(StringUtils.isNotBlank(model.getReceiverType()), "请输入PIKA系统收货点类型！");
        Assert.isTrue(StringUtils.isNotBlank(model.getDisSysName()), "请输入分料系统收货单位名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        model.setId(id);
        model.setUpdateManNo(UserUtil.getCurrentUserId());
        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        DynamicBaseReciever dynamicBaseReciever = dynamicBaseRecieverService.modify(model);
        return success(dynamicBaseReciever);
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasereciever:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        List<String> list = Arrays.asList(id.split(","));
        if (ListUtils.isNotEmpty(list)) {
            List<String> ids = ListUtils.convertList(list);
            dynamicBaseRecieverService.delete(ids);
        }
        return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response) throws IOException {
        List<DynamicBaseReciever> list = dynamicBaseRecieverService.query(null);
        ExcelUtil.exportExcel(response, list, DynamicBaseReciever.class, "收货单位信息");
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseCalibraRelation> list = dynamicBaseRecieverService.queryall(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
